// DetailBoardNetworkDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailBoardNetworkDlg.h"
#include "afxdialogex.h"


// CDetailBoardNetworkDlg _CAO

IMPLEMENT_DYNAMIC(CDetailBoardNetworkDlg, CDialog)

//CDetailBoardNetworkDlg::CDetailBoardNetworkDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CDetailBoardNetworkDlg::IDD, pParent)
//{
//
//}

CDetailBoardNetworkDlg::CDetailBoardNetworkDlg(sl::BoardConfig& board)
	: CDialog(CDetailBoardNetworkDlg::IDD, NULL)
	, board_(board)
{

}

CDetailBoardNetworkDlg::~CDetailBoardNetworkDlg()
{
}

void CDetailBoardNetworkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_CONTACT, m_xcCheckContact);
	DDX_Control(pDX, IDC_CHECK_CHANGE, m_xcCheckChange);
	DDX_Control(pDX, IDC_EDIT_USERAGENT, m_xcEditUserAgent);
	DDX_Control(pDX, IDC_SPIN_TIMEOUT, m_xcSpinTimeout);
	DDX_Control(pDX, IDC_EDIT_SHITARABA, m_xcEditShitaraba);
}

void CDetailBoardNetworkDlg::InitControls()
{
	m_xcCheckContact.SetCheck(board_.contact ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckChange.SetCheck(board_.change ? BST_CHECKED : BST_UNCHECKED);
	m_xcEditUserAgent.SetWindowText(board_.userAgent.c_str());
	m_xcSpinTimeout.SetPos32(board_.timeout);
	m_xcEditShitaraba.SetWindowText(board_.shitaraba.c_str());
}


BEGIN_MESSAGE_MAP(CDetailBoardNetworkDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailBoardNetworkDlg::OnBnClickedBtnAllDefault)
END_MESSAGE_MAP()


// CDetailBoardNetworkDlg bZ[W nh[


BOOL CDetailBoardNetworkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcSpinTimeout.SetRange32(0, 60000);

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailBoardNetworkDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailBoardNetworkDlg::OnDestroy()
{
	CDialog::OnDestroy();

	board_.contact = m_xcCheckContact.GetCheck() == BST_CHECKED;
	board_.change = m_xcCheckChange.GetCheck() == BST_CHECKED;
	CString userAgent;
	m_xcEditUserAgent.GetWindowText(userAgent);
	board_.userAgent = std::wstring(userAgent);
	board_.timeout = m_xcSpinTimeout.GetPos32();
	CString shitaraba;
	m_xcEditShitaraba.GetWindowText(shitaraba);
	board_.shitaraba = std::wstring(shitaraba);
}


void CDetailBoardNetworkDlg::OnBnClickedBtnAllDefault()
{
	auto tmp = sl::BoardConfig();
	board_.contact = tmp.contact;
	board_.change = tmp.change;
	board_.userAgent = tmp.userAgent;
	board_.timeout = tmp.timeout;
	board_.shitaraba = tmp.shitaraba;
	InitControls();
}
